package JoelCastellanosAnimations;

import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

import java.util.Random;

public class BouncingLine extends Animation
{

  private Canvas canvas;
  private GraphicsContext gtx;
  private double x1, y1, x2, y2;
  private double speedX1, speedY1;
  private double speedX2, speedY2;

  private Random random;
  private static final Color background = Color.rgb(255,200,200);


  public BouncingLine(Canvas canvas)
  {
    this.canvas = canvas;
    gtx = canvas.getGraphicsContext2D();



    random = new Random();

    x1 = random.nextDouble()*DRAW_WIDTH;
    x2 = random.nextDouble()*DRAW_WIDTH;

    y1 = random.nextDouble()*DRAW_HEIGHT;
    y2 = random.nextDouble()*DRAW_HEIGHT;

    speedX1 = random.nextDouble()*10 - 5;
    speedY1 = random.nextDouble()*10 - 5;
    speedX2 = random.nextDouble()*10 - 5;
    speedY2 = random.nextDouble()*10 - 5;


    gtx.setStroke(Color.BLUE);
    gtx.setLineWidth(3);

    gtx.setFill(background);
    gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);
  }


  public void handle(long now)
  {
    //             x1, y1, x2, y1
    gtx.strokeLine(x1,  y1, x2, y2);
    x1 += speedX1;
    y1 += speedY1;
    x2 += speedX2;
    y2 += speedY2;
    if (x1 > DRAW_WIDTH)
    {
      speedX1 = -random.nextDouble()*5;
      gtx.setFill(background);
      gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);
    }
    else if(x1 < 0)
    {
      speedX1 = random.nextDouble()*5;
      gtx.setFill(background);
      gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);
    }

    if (y1 > DRAW_HEIGHT)
    {
      speedY1 = -random.nextDouble()*5;
    }
    else if(y1 < 0)
    {
      speedY1 = random.nextDouble()*5;
    }




    if (x2 > DRAW_WIDTH)
    {
      speedX2 = -random.nextDouble()*5;
      gtx.setFill(background);
      gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);
    }
    else if(x2 < 0)
    {
      speedX2 = random.nextDouble()*5;
      gtx.setFill(background);
      gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);
    }

    if (y2 > DRAW_HEIGHT)
    {
      speedY2 = -random.nextDouble()*5;
    }
    else if(y2 < 0)
    {
      speedY2 = random.nextDouble()*5;
    }
  }
}
