package JoelCastellanosAnimations;

import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class LineDrawAnimation extends Animation
{
  private Canvas canvas;
  private GraphicsContext gtx;
  private int x = 0;
  private int speedX = 10;

  private long timeOfLastFrame = 0;

  public LineDrawAnimation(Canvas canvas)
  {
    this.canvas = canvas;
    gtx = canvas.getGraphicsContext2D();

    gtx.setFill(Color.WHITE);
    gtx.fillRect(0, 0, 500, 500);
    gtx.setStroke(Color.BLUE);


    gtx.setLineWidth(1);
    for (int a=0; a<500; a=a+25)
    { gtx.strokeLine(a, a, a, a+20);
      gtx.strokeLine(a, a, a+20, a);
    }


  }


  public void handle(long now)
  {
    if (now > 0) return;
    double timeDiff = now - timeOfLastFrame;
    //System.out.println((timeDiff/1_000_000_000.0));
    timeOfLastFrame = now;

    gtx.setLineWidth(3);

    //             x1, y1, x2, y1
    gtx.strokeLine(0,  0, x, DRAW_HEIGHT);
    x += speedX;
    if (x > DRAW_WIDTH)
    {
      speedX = -10;
      gtx.setStroke(Color.RED);
    }
    else if(x < 10)
    {
      speedX = 10;
      gtx.setStroke(Color.BLUE);
    }
  }
}
