package JoelCastellanosAnimations;

import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class SquareSprial extends Animation
{
  private Canvas canvas;
  private GraphicsContext gtx;
  private double x, y;
  private double delta;
  private int direction;
  private static final double[] dx = {1, 0, -1,  0};
  private static final double[] dy = {0, 1,  0, -1};
  private int step;


  private static final Color[] palette =
  {
    Color.rgb(48,72,170), Color.rgb(52,72,145), Color.rgb(184,162,40),
      Color.rgb(198,198,134)
  };
  private int paletteIdx = 0;


  private static final Color background = Color.rgb(255,200,200);


  public SquareSprial(Canvas canvas)
  {
    this.canvas = canvas;
    gtx = canvas.getGraphicsContext2D();

    restart();

    gtx.setLineWidth(3);

    gtx.setFill(background);
    gtx.fillRect(0, 0, DRAW_WIDTH, DRAW_HEIGHT);

  }


  public void handle(long now)
  {
    step++;
    //if (step % 10 != 0) return;

    double oldX = x;
    double oldY = y;

    x = x + delta*dx[direction];
    y = y + delta*dy[direction];

    delta += 5;
    direction = (direction + 1) % 4;

    //             x1, y1, x2, y1
    gtx.strokeLine(oldX,  oldY, x, y);

    if (x > DRAW_WIDTH || x < 0)
    {
      restart();
    }

  }


  private void restart()
  {
    step = 0;
    delta = 5;
    direction = 0;
    x = DRAW_WIDTH/2;
    y = DRAW_HEIGHT/2;


    gtx.setStroke(palette[paletteIdx]);
    paletteIdx = (paletteIdx + 1)%palette.length;
  }
}
