public class Print2DGridAndParticles
{
  /**
   * This small stand-alone example is designed to help debug the DLA project. It:
   *  1) creates a small 2D grid int array.
   *  2) creates a very short list of points.
   *  3) Assigns one element of the grid array to non-zero.
   *  4) Assigns the coordinates of the points in the list to be locations on the grid.
   *  5) Prints as text a representation of the point locations in place in the grid.
   */




  //=========================================================================================
  //  Print2DGridAndParticles()
  //=========================================================================================
  public Print2DGridAndParticles()
  {
    //Create the grid and array of points
    int gridWidth = 10;
    int gridHeight = 10;
    int[][] myGrid = new int[gridWidth][gridHeight];
    Point[] myPointList = new Point[3];

    myPointList[0] = new Point();
    myPointList[1] = new Point();
    myPointList[2] = new Point();



    //Assign a value to an element of the grid.
    myGrid[5][5] = 1;


    //Assign values to each element of the point list.
    myPointList[0].x = 2;
    myPointList[0].y = 9;

    myPointList[1].x = 5;
    myPointList[1].y = 9;

    myPointList[2].x = 7;
    myPointList[2].y = 9;


    //Print points and grid together.
    for (int y=0; y<gridHeight; y++)
    {
      for (int x=0; x<gridWidth; x++)
      {

        //Loop through all the points to see if one is in this grid space.
        boolean spaceHasPoint = false;
        for (int p=0; p<myPointList.length; p++)
        {
          if (myPointList[p].x == x && myPointList[p].y == y)
          {
            spaceHasPoint = true;
            System.out.print('o');
          }
        }


        //Only if a point was not found in this grid space, then print either
        //  a period if 0 is in the space.  Otherwise print an X.
        if (spaceHasPoint == false)
        {
          if (myGrid[x][y] == 0) System.out.print('.');
          else System.out.print('X');
        }
      }
      System.out.println(); //at the end of the x loop, we are done with a row.
    }
  }


  //=========================================================================================
  //  main()
  //=========================================================================================
  public static void main(String[] args)
  {
    new Print2DGridAndParticles();
  }


  //=========================================================================================
  //Inner Point class
  //=========================================================================================
  class Point
  {
    public int x, y;
  }
}
